def dodaj(a, b):
    return (a[0] + b[0], a[1] + b[1])

def obroc_w_lewo(v):
    return (-v[1], v[0])

def rozwiaz(n):
    if n == 0:
        return (0, 0)
    wykladnik = (n - 1).bit_length()
    return dodaj(przesuniecia_dla_poteg_2[wykladnik], obroc_w_lewo(rozwiaz((1 << wykladnik) - n)))

przesuniecia_dla_poteg_2 = [0] * 64
def stablicuj_przesuniecia():
    przesuniecie_x, przesuniecie_y = 0, 1
    for i in range(64):
        przesuniecia_dla_poteg_2[i] = (przesuniecie_x, przesuniecie_y)
        przesuniecie_x, przesuniecie_y = przesuniecie_x + przesuniecie_y, \
            przesuniecie_y - przesuniecie_x

stablicuj_przesuniecia()
t = int(input())
for _ in range(t):
    print(*rozwiaz(int(input())))
